## mingw-w64-castxml-0.6.5-1.src.tar.zst

=== CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================
cmake_minimum_required(VERSION 3.5)
project(CastXML)

include(src/Version.cmake)

include(CTest)

# Build tree locations.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CastXML_BINARY_DIR}/lib")

# Install tree locations.
if(NOT CastXML_INSTALL_RUNTIME_DIR)
  set(CastXML_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT CastXML_INSTALL_DATA_DIR)
  set(CastXML_INSTALL_DATA_DIR share/castxml)
endif()
if(NOT CastXML_INSTALL_DOC_DIR)
  set(CastXML_INSTALL_DOC_DIR share/doc/castxml)
endif()
if(NOT CastXML_INSTALL_MAN_DIR)
  set(CastXML_INSTALL_MAN_DIR man)
endif()

macro(hint_clang_from_llvm)
  if(LLVM_DIR AND NOT Clang_DIR)
    if(LLVM_DIR MATCHES "share/llvm/cmake$")
      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
      get_filename_component(Clang_DIR "${LLVM_DIR}/../../clang/cmake" ABSOLUTE)
    else()
      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
      get_filename_component(Clang_DIR "${LLVM_DIR}/../clang" ABSOLUTE)
    endif()
  endif()
endmacro()

macro(hint_llvm_from_clang)
  if(Clang_DIR AND NOT LLVM_DIR)
    if(Clang_DIR MATCHES "share/clang/cmake$")
      # LLVM/Clang 3.8 installs in <prefix>/share/{llvm,clang}/cmake
      get_filename_component(LLVM_DIR "${Clang_DIR}/../../llvm/cmake" ABSOLUTE)
    else()
      # LLVM/Clang 3.9+ installs in <prefix>/lib/cmake/{llvm,clang}
      get_filename_component(LLVM_DIR "${Clang_DIR}/../llvm" ABSOLUTE)
    endif()
  endif()
endmacro()

# Build scripts may set either LLVM_DIR or Clang_DIR.
hint_llvm_from_clang()
hint_clang_from_llvm()

# If several LLVM versions provide CMake packages, try to use the latest one.
set(CMAKE_FIND_PACKAGE_SORT_ORDER NATURAL)
set(CMAKE_FIND_PACKAGE_SORT_DIRECTION DEC)

# Clang 3.8+ installs its own CMake package.  Try it first.
find_package(Clang QUIET)

# If Clang did not find LLVM for us, give our search below a hint.
hint_llvm_from_clang()

# Clang 3.9+ automatically searches for LLVM.  For older versions we
# may need to search for LLVM directly.  Either way we require LLVM.
if(NOT LLVM_FOUND)
  find_package(LLVM REQUIRED)
endif()

if(DEFINED LLVM_BUILD_BINARY_DIR)
  message(FATAL_ERROR
    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang build directory:\n"
    "  Clang_DIR=${Clang_DIR}\n"
    "  LLVM_DIR=${LLVM_DIR}\n"
    "CastXML must be built against a LLVM/Clang install tree as "
    "specified in\n"
    "  ${CastXML_SOURCE_DIR}/README.rst")
endif()

set(found_clang 0)
set(tried_clang)
foreach(inc ${CLANG_INCLUDE_DIRS} ${LLVM_INCLUDE_DIRS})
  if(EXISTS "${inc}/clang/AST/ASTConsumer.h")
    set(found_clang 1)
    break()
  else()
    set(tried_clang "  ${inc}\n")
  endif()
endforeach()
if(NOT found_clang)
  message(FATAL_ERROR
    "Clang_DIR or LLVM_DIR refers to a LLVM/Clang installation:\n"
    "  Clang_DIR=${Clang_DIR}\n"
    "  LLVM_DIR=${LLVM_DIR}\n"
    "that does not have `clang/` headers in any include directory:\n"
    "${tried_clang}"
    )
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
  if(NOT LLVM_ENABLE_EH)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
  endif()
  if(NOT LLVM_ENABLE_RTTI)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  string(APPEND CMAKE_CXX_FLAGS " -Zc:preprocessor")
endif()
if(CYGWIN OR MINGW)
  # Use GNU extensions on Windows as LLVM upstream does.
  set(CMAKE_CXX_EXTENSIONS ON)
else()
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()
if(LLVM_VERSION_MAJOR GREATER 15)
  set(CMAKE_CXX_STANDARD 17)
elseif(LLVM_VERSION_MAJOR GREATER 9)
  set(CMAKE_CXX_STANDARD 14)
else()
  set(CMAKE_CXX_STANDARD 11)
endif()

# Reserve ~10MB stack size on Windows, as LLVM upstream does.
if(MSVC)
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -STACK:10000000")
endif()

add_definitions(${LLVM_DEFINITIONS})
include_directories(${CLANG_INCLUDE_DIRS})
include_directories(${LLVM_INCLUDE_DIRS})
link_directories(${LLVM_LIBRARY_DIRS})
if(NOT DEFINED LLVM_VERSION_PATCH)
  set(LLVM_VERSION_PATCH 0)
endif()

set(CLANG_RESOURCE_DIR "" CACHE PATH "Clang resource directory")
if(NOT CLANG_RESOURCE_DIR)
  set(v ${LLVM_VERSION_MAJOR}.${LLVM_VERSION_MINOR}.${LLVM_VERSION_PATCH})
  set(tried "")
  set(dirs "")
  foreach(d ${LLVM_LIBRARY_DIRS})
    # Clang resources are typically inside LLVM's library directory.
    list(APPEND dirs ${d})
    # Some distros use a layout of the form
    #     <prefix>/lib/llvm/<major-version>/lib
    #     <prefix>/lib/clang/<full-version>/include
    if("${d}" MATCHES "^(.*)/llvm/.*$")
      list(APPEND dirs "${CMAKE_MATCH_1}")
    endif()
  endforeach()
  # Look in each candidate directory for Clang resources.
  foreach(d ${dirs})
    if(IS_DIRECTORY "${d}/clang/${v}/include")
      set(CLANG_RESOURCE_DIR ${d}/clang/${v})
      break()
    elseif(IS_DIRECTORY "${d}/clang/${LLVM_VERSION_MAJOR}/include")
      set(CLANG_RESOURCE_DIR ${d}/clang/${LLVM_VERSION_MAJOR})
      break()
    endif()
    set(tried "${tried}\n  ${d}/clang/${v}")
  endforeach()
  if(NOT CLANG_RESOURCE_DIR)
    if(tried)
      set(tried "  Tried:${tried}")
    endif()
    message(FATAL_ERROR "Could not find CLANG_RESOURCE_DIR.${tried}"
      "\n"
      "Please set CLANG_RESOURCE_DIR to the Clang SDK directory containing "
      "\"include/stddef.h\", typically of the form \"<prefix>/lib/clang/${v}\"."
      )
  endif()
  unset(tried)
endif()

install(DIRECTORY ${CLANG_RESOURCE_DIR}/include
  DESTINATION "${CastXML_INSTALL_DATA_DIR}/clang"
  )

add_subdirectory(src)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

add_subdirectory(doc)

install(DIRECTORY share/castxml/ DESTINATION "${CastXML_INSTALL_DATA_DIR}")

install(FILES
  "LICENSE"
  "NOTICE"
  DESTINATION "${CastXML_INSTALL_DOC_DIR}"
  )

=== test/CMakeLists.txt ===
#=============================================================================
# Copyright Kitware, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#=============================================================================

# Keep test binaries away from main binaries.
unset(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
unset(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset(CMAKE_ARCHIVE_OUTPUT_DIRECTORY)

find_package(LibXml2 QUIET)

macro(castxml_test_cmd test)
  set(command $<TARGET_FILE:castxml> ${ARGN})
  set(_castxml_expect ${castxml_test_cmd_expect} cmd.${test})
  add_test(
    NAME cmd.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    ${castxml_test_cmd_extra_arguments}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_common prefix ext std test)
  if(DEFINED castxml_test_output_custom_start)
    set(_castxml_start ${castxml_test_output_custom_start})
  else()
    set(_castxml_start --castxml-start start)
  endif()
  if(castxml_test_output_custom_input)
    set(_castxml_input ${castxml_test_output_custom_input})
  else()
    set(_castxml_input ${test})
  endif()
  set(_castxml_expect ${prefix}.${std}.${test})
  if("${std}" MATCHES "^gnu(.*)$")
    list(APPEND _castxml_expect ${prefix}.c${CMAKE_MATCH_1}.${test})
  endif()
  if("${std}" MATCHES "^(c|gnu)[^+]")
    list(APPEND _castxml_expect ${prefix}.c.${test})
  endif()
  list(APPEND _castxml_expect ${prefix}.any.${test})

  if ("${prefix}" MATCHES "^gccxml(.*)$")
    set(flag --castxml-gccxml)
  elseif ("${prefix}" MATCHES "^castxml1(.*)$")
    set(flag --castxml-output=1)
  endif()

  set(std_flag -std=${std})
  if(LLVM_VERSION_MAJOR VERSION_LESS 5)
    if("${std_flag}" MATCHES "^(.*)17$")
      set(std_flag "${CMAKE_MATCH_1}1z")
    endif()
  endif()

  set(_schema "${CastXML_SOURCE_DIR}/doc/manual/castxml.xsd")

  set(command $<TARGET_FILE:castxml>
    ${flag}
    ${_castxml_start}
    ${std_flag}
    ${CMAKE_CURRENT_LIST_DIR}/input/${_castxml_input}.${ext}
    -o ${prefix}.${std}.${test}.xml
    ${castxml_test_output_extra_arguments}
    )
  add_test(
    NAME ${prefix}.${std}.${test}
    COMMAND ${CMAKE_COMMAND}
    "-Dcommand:STRING=${command}"
    "-Dexpect=${_castxml_expect}"
    "-Dxml=${prefix}.${std}.${test}.xml"
    "-Dxmllint=${LIBXML2_XMLLINT_EXECUTABLE}"
    "-Dschema=${_schema}"
    -P ${CMAKE_CURRENT_SOURCE_DIR}/run.cmake
    )
endmacro()

macro(castxml_test_output_c89 test)
  castxml_test_output_common(gccxml c c89 ${test})
  castxml_test_output_common(castxml1 c c89 ${test})
endmacro()

macro(castxml_test_output_c99 test)
  castxml_test_output_common(gccxml c c99 ${test})
  castxml_test_output_common(castxml1 c c99 ${test})
endmacro()

macro(castxml_test_output_c11 test)
  castxml_test_output_common(gccxml c c11 ${test})
  castxml_test_output_common(castxml1 c c11 ${test})
endmacro()

macro(castxml_test_output_gnu89 test)
  castxml_test_output_common(gccxml c gnu89 ${test})
  castxml_test_output_common(castxml1 c gnu89 ${test})
endmacro()

macro(castxml_test_output_gnu99 test)
  castxml_test_output_common(gccxml c gnu99 ${test})
  castxml_test_output_common(castxml1 c gnu99 ${test})
endmacro()

macro(castxml_test_output_gnu11 test)
  castxml_test_output_common(gccxml c gnu11 ${test})
  castxml_test_output_common(castxml1 c gnu11 ${test})
endmacro()

macro(castxml_test_output_cxx98 test)
  castxml_test_output_common(gccxml cxx c++98 ${test})
  castxml_test_output_common(castxml1 cxx c++98 ${test})
endmacro()

macro(castxml_test_output_gnuxx98 test)
  castxml_test_output_common(gccxml cxx gnu++98 ${test})
  castxml_test_output_common(castxml1 cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_cxx11 test)
  castxml_test_output_common(gccxml cxx c++11 ${test})
  castxml_test_output_common(castxml1 cxx c++11 ${test})
endmacro()

macro(castxml_test_output_gnuxx11 test)
  castxml_test_output_common(gccxml cxx gnu++11 ${test})
  castxml_test_output_common(castxml1 cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_cxx14 test)
  castxml_test_output_common(gccxml cxx c++14 ${test})
  castxml_test_output_common(castxml1 cxx c++14 ${test})
endmacro()

macro(castxml_test_output_gnuxx14 test)
  castxml_test_output_common(gccxml cxx gnu++14 ${test})
  castxml_test_output_common(castxml1 cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_cxx17 test)
  castxml_test_output_common(gccxml cxx c++17 ${test})
  castxml_test_output_common(castxml1 cxx c++17 ${test})
endmacro()

macro(castxml_test_output_gnuxx17 test)
  castxml_test_output_common(gccxml cxx gnu++17 ${test})
  castxml_test_output_common(castxml1 cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_cxx20 test)
  castxml_test_output_common(gccxml cxx c++20 ${test})
  castxml_test_output_common(castxml1 cxx c++20 ${test})
endmacro()

macro(castxml_test_output_gnuxx20 test)
  castxml_test_output_common(gccxml cxx gnu++20 ${test})
  castxml_test_output_common(castxml1 cxx gnu++20 ${test})
endmacro()

macro(castxml_test_output_broken_cxx98 test)
  castxml_test_output_common(gccxml.broken cxx c++98 ${test})
  castxml_test_output_common(castxml1.broken cxx c++98 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx98 test)
  castxml_test_output_common(gccxml.broken cxx gnu++98 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++98 ${test})
endmacro()

macro(castxml_test_output_broken_cxx11 test)
  castxml_test_output_common(gccxml.broken cxx c++11 ${test})
  castxml_test_output_common(castxml1.broken cxx c++11 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx11 test)
  castxml_test_output_common(gccxml.broken cxx gnu++11 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++11 ${test})
endmacro()

macro(castxml_test_output_broken_cxx14 test)
  castxml_test_output_common(gccxml.broken cxx c++14 ${test})
  castxml_test_output_common(castxml1.broken cxx c++14 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx14 test)
  castxml_test_output_common(gccxml.broken cxx gnu++14 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++14 ${test})
endmacro()

macro(castxml_test_output_broken_cxx17 test)
  castxml_test_output_common(gccxml.broken cxx c++17 ${test})
  castxml_test_output_common(castxml1.broken cxx c++17 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx17 test)
  castxml_test_output_common(gccxml.broken cxx gnu++17 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++17 ${test})
endmacro()

macro(castxml_test_output_broken_cxx20 test)
  castxml_test_output_common(gccxml.broken cxx c++20 ${test})
  castxml_test_output_common(castxml1.broken cxx c++20 ${test})
endmacro()

macro(castxml_test_output_broken_gnuxx20 test)
  castxml_test_output_common(gccxml.broken cxx gnu++20 ${test})
  castxml_test_output_common(castxml1.broken cxx gnu++20 ${test})
endmacro()

macro(castxml_test_output_c test)
  castxml_test_output_c89(${test})
  castxml_test_output_gnu89(${test})
  castxml_test_output_c99(${test})
  castxml_test_output_gnu99(${test})
  castxml_test_output_c11(${test})
  castxml_test_output_gnu11(${test})
endmacro()

macro(castxml_test_output test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_11 test)
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_14 test)
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
  castxml_test_output_cxx17(${test})
  castxml_test_output_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_cxx20(${test})
    castxml_test_output_gnuxx20(${test})
  endif()
endmacro()

macro(castxml_test_output_14below test)
  castxml_test_output_cxx98(${test})
  castxml_test_output_gnuxx98(${test})
  castxml_test_output_cxx11(${test})
  castxml_test_output_gnuxx11(${test})
  castxml_test_output_cxx14(${test})
  castxml_test_output_gnuxx14(${test})
endmacro()

macro(castxml_test_output_broken test)
  castxml_test_output_broken_cxx98(${test})
  castxml_test_output_broken_gnuxx98(${test})
  castxml_test_output_broken_cxx11(${test})
  castxml_test_output_broken_gnuxx11(${test})
  castxml_test_output_broken_cxx14(${test})
  castxml_test_output_broken_gnuxx14(${test})
  castxml_test_output_broken_cxx17(${test})
  castxml_test_output_broken_gnuxx17(${test})
  if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
    castxml_test_output_broken_cxx20(${test})
    castxml_test_output_broken_gnuxx20(${test})
  endif()
endmacro()

set(input ${CMAKE_CURRENT_LIST_DIR}/input)
set(empty_c ${input}/empty.c)
set(empty_cxx ${input}/empty.cxx)
set(empty_m ${input}/empty.m)
set(empty_mm ${input}/empty.mm)

castxml_test_cmd(help1 -help)
castxml_test_cmd(help2 --help)
castxml_test_cmd(no-arguments)
castxml_test_cmd(version --version)

castxml_test_cmd(cc-missing --castxml-cc-gnu)
castxml_test_cmd(cc-option --castxml-cc-gnu -)
castxml_test_cmd(cc-paren-castxml --castxml-cc-gnu "(" --castxml-cc-msvc ")")
castxml_test_cmd(cc-paren-nested --castxml-cc-gnu "(" "(" ")" ")")
castxml_test_cmd(cc-paren-unbalanced --castxml-cc-gnu "(")
castxml_test_cmd(cc-twice --castxml-cc-msvc cl --castxml-cc-gnu gcc)
castxml_test_cmd(cc-unknown --castxml-cc-unknown cc)

castxml_test_cmd(gccxml-and-E --castxml-gccxml -E)
castxml_test_cmd(castxml-and-E --castxml-output=1 -E)

castxml_test_cmd(gccxml-twice --castxml-gccxml --castxml-gccxml)
castxml_test_cmd(castxml-twice --castxml-output=1 --castxml-output=1)

castxml_test_cmd(castxml-mix1 --castxml-gccxml --castxml-output=1)
castxml_test_cmd(castxml-mix2 --castxml-output=1 --castxml-gccxml)

castxml_test_cmd(castxml-wrong-epic-version --castxml-output=0)

castxml_test_cmd(gccxml-and-c99 --castxml-gccxml -std=c99 ${empty_c})
castxml_test_cmd(castxml-and-c99 --castxml-output=1 -std=c99 ${empty_c})

castxml_test_cmd(gccxml-and-c11 --castxml-gccxml -std=c11 ${empty_c})
castxml_test_cmd(castxml-and-c11 --castxml-output=1 -std=c11 ${empty_c})

castxml_test_cmd(gccxml-and-c++11 --castxml-gccxml -std=c++11 ${empty_cxx})
castxml_test_cmd(castxml-and-c++11 --castxml-output=1 -std=c++11 ${empty_cxx})

castxml_test_cmd(gccxml-and-c++14 --castxml-gccxml -std=c++14 ${empty_cxx})
castxml_test_cmd(castxml-and-c++14 --castxml-output=1 -std=c++14 ${empty_cxx})

if(LLVM_VERSION_MAJOR VERSION_LESS 5)
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++1z ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++1z ${empty_cxx})
else()
  castxml_test_cmd(gccxml-and-c++17 --castxml-gccxml -std=c++17 ${empty_cxx})
  castxml_test_cmd(castxml-and-c++17 --castxml-output=1 -std=c++17 ${empty_cxx})
endif()

if(LLVM_VERSION_MAJOR VERSION_GREATER_EQUAL 11)
  castxml_test_cmd(gccxml-and-c++20 --castxml-gccxml -std=c++20 ${empty_cxx})

=== PKGBUILD ===
# Maintainer: Chris Gorman <chrisjohgorman@gmail.com>

_realname=castxml
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.6.5
pkgrel=1
pkgdesc="C-family abstract syntax tree XML output tool. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/CastXML/CastXML'
license=(Apache)
depends=("${MINGW_PACKAGE_PREFIX}-llvm"
	 "${MINGW_PACKAGE_PREFIX}-clang"
	 "${MINGW_PACKAGE_PREFIX}-clang-tools-extra")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-python-sphinx")
source=(${_realname}-${pkgver}.tar.gz::https://github.com/CastXML/CastXML/archive/v${pkgver}.tar.gz)
sha256sums=('fea4754bdb1fb4496fec12352e2bd07854843aa757e85d0553f224ff0111c482')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DCLANG_LINK_CLANG_DYLIB=1 \
      -DSPHINX_EXECUTABLE=/usr/bin/sphinx-build \
      -DSPHINX_HTML=0 \
      -DSPHINX_MAN=0 \
      -DCastXML_INSTALL_DOC_DIR=share/doc/castxml \
      -DCastXML_INSTALL_MAN_DIR=share/man \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

# 2024/05/26 - as of today there are three failing tests
#
#The following tests FAILED:
#         49 - cmd.fbracket-depth (Failed)
#         50 - cmd.gccxml-predefined-macros (Failed)
#         51 - cmd.castxml-predefined-macros (Failed)
# Disabiling this for now as it has ~=4700 tests and takes a while and also since it fails
#check() {
#  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}" --target test
#}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
